var trida_inputu = ["pr1","pr2","pr3"];
var pole_jmen = ["Šustová","Hliník","Nezbeda","Šťastná","Nguyễn","Brunclík"];
var vyz_graf;

class pr_zadani{
  constructor(kam){
    this.location = kam;
    this.val = new Array(6);
    this.val[0] = Math.floor(Math.random() * 23)+6;
    this.val[1] = Math.floor(Math.random() * 23)+6;
    this.val[2] = Math.floor(Math.random() * 23)+6;
    this.val[3] = Math.floor(Math.random() * 23)+6;
    this.val[4] = Math.floor(Math.random() * 23)+6;
    this.val[5] = Math.floor(Math.random() * 23)+6;
  }

  print(priklad){
    let tmp_array = [0,1,2,3,4,5];    //prohazet
    if(priklad != 1){
      let tmp_var, tmp_index;
      for(let x = 0; x<5; x++){
        tmp_index = Math.floor(Math.random()*5);
        tmp_var = tmp_array[tmp_index];
        tmp_array[tmp_index] = tmp_array[x];
        tmp_array[x] = tmp_var;
      }
    }
    let string_zadani = "";
    let suma = 0;
    for(let x = 0; x<6; x++){
      suma += this.val[x];
      string_zadani += pole_jmen[tmp_array[x]]+"\u202F" + this.val[tmp_array[x]] + "\u202Fkg";
      if(x == 4)
        string_zadani += " a\u202F";
      else if(x<4)
        string_zadani += ", "
    }
    string_zadani = "Dohromady nasbírali " + suma + "\u202Fkg papíru. " + string_zadani + ".";
    document.getElementById(this.location).innerText = string_zadani;
  }

}


class pr_select{
  constructor(rodic,id_prikladu){
    this.rodic = rodic;
    this.value = Math.floor(Math.random() * 25)+1;
    this.min = 0;
    this.max = 29;
    this.priklad = id_prikladu;
  }

  create(){
    let element = document.createElement('input');
    element.setAttribute("type","number");
    element.setAttribute("class",trida_inputu[this.priklad] + " cap1");
    element.setAttribute("value",this.value);
    element.setAttribute("min",this.min);
    element.setAttribute("max",this.max);
    document.getElementById(this.rodic).appendChild(element);
  }
}


class graf{
  constructor(kam,id_prikladu){
    this.variable = [];
    this.rodic = kam;
    this.priklad = id_prikladu;
    let inputy = document.getElementsByClassName(trida_inputu[this.priklad]);
    for(let i = 0;i<inputy.length;i++){
      if(inputy[i].value>0)
        this.variable[i] = inputy[i].value;
      else
        this.variable[i] = 0;
    }
  }

  print_info(){
    let graf_data = [];
    for(let i = 0;i<this.variable.length;i++){
      graf_data.push(this.variable[i]);
    }
    draw_column_chart(this.rodic,graf_data,pole_jmen,"Sběr papíru",true);
  }
}

function addListener(graf_id,id_prikladu){
  let inputy = document.getElementsByClassName(trida_inputu[id_prikladu]);
  for(let i = 0;i<inputy.length;i++){
    inputy[i].addEventListener("change", function(){
        var vyz_graf = new graf(graf_id,id_prikladu);
        vyz_graf.print_info();
    });
  }
}

class pr_tlacitko{
  constructor(id, string_val,id_prikladu){
    this.type = "submit";
    this.value = string_val;
    this.st_class = "cap1";
    this.id = id;
    this.priklad = id_prikladu;
  }

  create(obal_div){
    let element = document.createElement('input');
    element.setAttribute("type",this.type);
    element.setAttribute("class",this.st_class);
    element.setAttribute("value",this.value);
    element.setAttribute("id",this.id);
    let obal = document.getElementById(obal_div);
    obal.innerHTML = "";
    obal.appendChild(element);
  }

  addListener(ele,id_prikladu){
    let element = document.getElementById(ele);
    element.addEventListener("click", function(){
        kontrola(id_prikladu);
    });
  }
}

//kresleni grafu
function draw_column_chart(kam,datas,labels,title,ukaz){
			var ctx = document.getElementById(kam).getContext('2d');
      var config = {
  				type: 'bar',
  				data: {
      			labels: labels,
      			datasets: [{
      				label: 'papír [kg]',
      				backgroundColor: window.chartColors.blue,
      				borderColor: window.chartColors.blue,
      				borderWidth: 1,
      				data: datas
      			}]
      		},
  				options: {
            animation: false,
  					responsive: true,
            scales: {yAxes:[{ticks: {beginAtZero: true, max: 29}}]},
            plugins: {
    					datalabels: {
                align: 'end',
                anchor: 'end',
    					color: function(context) {
    						return context.dataset.backgroundColor;
    					},
    					font: function(context) {
                var w = context.chart.width;
                return {size: w < 512 ? 12 : 14}
              },
              display: ukaz,
    					}
    				},
  					legend: {
  						position: 'top',
  					},
  					title: {
  						display: true,
              fontSize: 18,
  						text: title
  					},
            responsive: true,
            events: [],
            tooltips: { enabled: false},
            legend: {
              position: "bottom",
              onClick: function (e) { e.stopPropagation(); }
            }
  				}
  		}
			window.myBar = new Chart(ctx, config);
}

//funkce na kontrolu zadani
function kontrola(priklad){
  let spravne = true;
  let nok_zaci = [];
  let string_netr = "";
  let pocetOK = 0;
  let inputy = document.getElementsByClassName(trida_inputu[priklad]);
  for(let x = 0;x<inputy.length;x++)
    if(zadani[priklad].val[x] != parseInt(inputy[x].value)){
      spravne = false;
      nok_zaci.push(pole_jmen[x]);
    }else
      pocetOK++;

  if(priklad != 2){
    if(pocetOK < 3) string_netr = "Pár jich máš správně.";
    else if(pocetOK == 3) string_netr = "Polovinu jich máš správně.";
    else string_netr = "Většinu jich máš správně.";
    let zaci = "";
    for(let z=0;z<nok_zaci.length;z++){
      if(z==nok_zaci.length-1 && z!=0) zaci +=" a ";
      else  if(z!=0) zaci += ", ";
      zaci += nok_zaci[z];
    }
    string_netr += " Zkontroluj ale ještě údaj pro žáky: "+zaci+".";
  }else string_netr = "Něco se povedlo, ale ještě to není správně.";


  if(spravne == true) print_modal("modal","ok");
  else
    if(pocetOK == 0)
      print_modal("modal","chyba");
    else{
      print_modal("modal","neutr",string_netr);
    }
}



///////////////////////////////
//hlavni vykon
//////////////////////////////
var zadani = [null,null,null];
for(let x=1;x<=3;x++){
  zadani[x-1] = new pr_zadani('zadani_'+x);
  zadani[x-1].print(x);

  var select_array = new Array(6);
  let obal_number = document.getElementById('inputs_'+x);
  obal_number.innerHTML = "";
  for(let i=0;i<6;i++){
    select_array[i] = new pr_select('inputs_'+x,x-1);
    select_array[i].create();
  }
  //listener pro selecty
  addListener('graf_'+x,x-1);

  //tlacitko
  var tlacitko_1 = new pr_tlacitko('pr_tlacitko_'+x,'Zkontroluj',x-1);
  tlacitko_1.create('tlac_obal_'+x);
  tlacitko_1.addListener('pr_tlacitko_'+x,x-1);

  //vykresleni
  var vyz_graf = new graf('graf_'+x,x-1);
  vyz_graf.print_info();
}
